﻿using Infragistics;
using Infragistics.Controls.Charts;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Reflection;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace XamDataChartOlapStackedSeriesCase
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
        }

        StackedColumnSeries series;
        int seriesIndex = 0;
        private void xAxis_SeriesInitializing(object sender, Infragistics.Controls.Charts.SeriesInitializingEventArgs e)
        {
            series = new StackedColumnSeries();
            seriesIndex = 0;
        }

        private void xAxis_SeriesCreating(object sender, Infragistics.Controls.Charts.SeriesCreatingEventArgs e)
        {
            if (seriesIndex == 0)
            {
                series.ItemsSource = Enumerable.Range(0, e.SeriesInfo.ItemsSource.Count).Select(i => new StackedSeriesData()).ToList();
            }
            for (int i = 0; i < e.SeriesInfo.ItemsSource.Count; i++)
            {
                ((List<StackedSeriesData>)series.ItemsSource)[i].Data.Add(Convert.ToDouble(e.SeriesInfo.ItemsSource[i].Cell.Value));
            }
            
            series.Series.Add(new StackedFragmentSeries() { ValueMemberPath = string.Format("Data[{0}]", seriesIndex), Title = e.SeriesInfo.Title, ShowDefaultTooltip = true });
            e.Series = series;
            seriesIndex++;
        }

        private void XamDataChart_MouseDoubleClick(object sender, MouseButtonEventArgs e)
        {
            if(e.OriginalSource is Rectangle)
            {
                Rectangle rect = e.OriginalSource as Rectangle;
                Infragistics.Controls.Charts.DataContext context = rect.DataContext as Infragistics.Controls.Charts.DataContext;

                if(context != null)
                {                    
                    ColumnFragment fragment = context.Series as ColumnFragment;

                    PropertyInfo propInfo = fragment.GetType().GetProperty("ValueColumn", System.Reflection.BindingFlags.Instance | System.Reflection.BindingFlags.NonPublic);

                    var x = propInfo.GetValue(fragment);

                    PropertyInfo valuesInfo = x.GetType().GetProperty("Values", BindingFlags.NonPublic | BindingFlags.Instance);

                    List<double> values = valuesInfo.GetValue(x) as List<double>;

                    Canvas canvas = fragment.RootCanvas;

                    int index = canvas.Children.IndexOf(rect);

                    string tooltip = fragment.Title + ": " + values[index - 1].ToString();

                    MessageBox.Show("Tooltip = " + tooltip);
                }
            }
        }      
    }

    public class StackedSeriesData
    {
        public StackedSeriesData()
        {
            Data = new List<double>();
        }

        public List<double> Data { get; set; }
    }
}
